
local Dolmen = ...

if (foundation.getGameVersion == nil or version.cmp(foundation.getGameVersion(), "1.6") < 0) then
        Dolmen:log("Hello World: game version anterior to 1.6")
        _DolmenBuildingZone = { Polygon = polygon.createRectangle( {4, 4} ) } 
else
        Dolmen:log("Hello World: game version " .. foundation.getGameVersion())
        _DolmenBuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createRectangle( {4, 4} ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
        }}
        Dolmen:registerEnumValue ("BUILDING_PART_TYPE", "DECORATION")
end

Dolmen:registerAssetId("models/dolmen.fbx/Prefab/dolmenPart", "DOLMEN_PREFAB")

-- Register the stone gate set decoration dolmen part
Dolmen:register({
	DataType = "BUILDING_PART",
	Id = "DOLMEN_PART",
	Name = "DOLMEN_NAME",
	Description = "DOLMEN_DESC",
	Category = "DECORATION",
        BuildingZone = _DolmenBuildingZone,
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "DOLMEN_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 5 }
		}
	},
        VillagerCapacity = 4,
        Capacity = 4,
  	AssetBuildingFunction = "MENHIR_FUNCTION"
})

-- Register grounding components

Dolmen:registerPrefabComponent("models/dolmen.fbx/Prefab/dolmenPart", {
	DataType = "COMP_GROUNDED"
})

-- Override building part components properties (generated by the building asset processor) to add building zones
Dolmen:registerPrefabComponent("models/dolmen.fbx/Prefab/dolmenPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 4, 4 }
})
