
local Menhir = ...

if (foundation.getGameVersion == nil or version.cmp(foundation.getGameVersion(), "1.6") < 0) then
        Menhir:log("Hello World: game version anterior to 1.6")
        _MenhirBuildingZone = { Polygon = polygon.createRectangle( {1, 1} ) } 
else
        Menhir:log("Hello World: game version " .. foundation.getGameVersion())
        _MenhirBuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createRectangle( {1, 1} ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
        }}
        Menhir:registerEnumValue ("BUILDING_PART_TYPE", "DECORATION")
end

Menhir:registerAssetId("models/menhir.fbx/Prefab/menhirPart", "MENHIR_PREFAB")

-- Register the stone gate set decoration menhir part
Menhir:register({
	DataType = "BUILDING_PART",
	Id = "MENHIR_PART",
	Name = "MENHIR_NAME",
	Description = "MENHIR_DESC",
	Category = "DECORATION",
        BuildingZone = _MenhirBuildingZone,
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "MENHIR_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 1 }
		}
	},
        VillagerCapacity = 1,
        Capacity = 1,
  	AssetBuildingFunction = "MENHIR_FUNCTION"
})

Menhir:register({
		DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
                Id = "MENHIR_FUNCTION",
                ResourceGenerated = "FAITH",
                IsInfinite = false
})


-- Register grounding components

Menhir:registerPrefabComponent("models/menhir.fbx/Prefab/menhirPart", {
	DataType = "COMP_GROUNDED"
})

-- Override building part components properties (generated by the building asset processor) to add building zones
Menhir:registerPrefabComponent("models/menhir.fbx/Prefab/menhirPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 1, 1 }
})
